#!/usr/local/bin/perl -w

open NEWSLETTER, "<", $ARGV[0];
open the_news, ">", "new_news.html";
my @lines = <NEWSLETTER>;
close NEWSLETTER;

my $startflag = 0;
my $paragraph = '';
my $the_doc = '';

foreach $line (@lines) {
	if ("$line" =~ "<BODY"){
		$startflag = 1;
	}
	elsif ("$line" =~ "</BODY"){
		$startflag = 0;
	}

	if ($startflag == 1)
	{
		$line =~ s{<P[^\<]*\>}{\<P\>}g;
		#$line =~ s{<FONT SIZE=4>}{<h2>}g;
		$line =~ s{<FONT SIZE=[^\<]*\>}{}g;
		$line =~ s{</FONT>}{}g;
	
		foreach $tag ('TABLE', 'COL', 'TR', 'TD', 'FONT FACE', 'FONT COLOR'){
			$line =~ s{<$tag[^\<]*\>}{}g;
			$line =~ s{</$tag>}{}g;
		}
		
		$line =~ s{\xe2\x80\x99}{\'}g;
		$line =~ s{\xe2\x80\x98}{\'}g;
		$line =~ s{\xe2\x80\x9c}{\"}g;
		$line =~ s{\xe2\x80\x9d}{\"}g;
		$line =~ s{[\t]}{}g;	
		$line =~ s{NAME=[^\>]*\>}{>}g;
		if("$line" =~ "<BR>"){
			
			$line =~ s{<BR>}{}g;
		}

		if("$line" =~ "</P>" || "$line" =~ "</p>"){		
			$paragraph .= " $line";
			$paragraph =~ s{\n}{}g;
			$paragraph =~ s{>^[\t]<}{><}g;
			foreach $tag ('B', 'U', 'I'){
				$paragraph =~ s{</$tag><$tag>}{}g;
				$paragraph =~ s{<$tag></$tag>}{}g;
			}

			if("$paragraph" =~ m/h2/){
				$paragraph =~ s{<.*?>}{}g;
				$paragraph = "<h2>$paragraph</h2>";
			}
			if ($paragraph =~ "<UL>" || $paragraph =~ "<OL>"){
				$paragraph =~ s{<UL>}{<P><UL>}g;
				$paragraph =~ s{<OL>}{<P><OL>}g					
			}
			if ($paragraph =~ "</UL>" || $paragraph =~ "</OL>"){
				$paragraph =~ s{</UL>}{</UL></P>}g;
				$paragraph =~ s{</OL>}{</OL></P>}g;
			}
			if ($paragraph =~ "<LI>"){
				$paragraph = "$paragraph</LI>";
				$paragraph =~ s{<LI><P>}{<LI>}g;
				$paragraph =~ s{</P></LI>}{</LI>}g;
			}

			if ($paragraph =~ '[A-Z][A-Z][A-Z][A-Z]'){
				$paragraph = lc("$paragraph");
				$paragraph =~ s{ i }{ I }g;
				$paragraph =~ s{ i\'m }{ I\'m }g;
				$paragraph =~ s{>([a-z])(\w+)\b}{>\u$1$2}g;
				$paragraph =~ s{\.  ([a-z])(\w+)\b}{\. \u$1$2}g;
				if($paragraph =~ '<h2>'){
					$paragraph =~ s{\b([a-z])(\w+)\b}{\u$1$2}g;
				}
			}
			$paragraph =~ s{> <}{><}g;
			$paragraph =~ s{<[A-Z]></[A-Z]>}{}g;
			$paragraph =~ s{<[a-z]></[a-z]>}{}g;
			$paragraph =~ s{</[A-Z]><[A-Z]>}{}g;
			$paragraph =~ s{</[a-z]><[a-z]>}{}g;
			#$the_doc .= "$paragraph\n\n";

			print the_news "$paragraph\n";
			$paragraph = '';
		}else{
			$paragraph .= " $line";
		}
	}
	
}
#$the_doc =~ s{>}{>\n}g;
print the_news $the_doc;

close the_news;
